// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package bob

import (
	"context"

	"github.com/stephenafamo/bob/dialect/psql"
	"github.com/stephenafamo/bob/dialect/psql/dialect"
)

var TableNames = struct {
	Animes     string
	Users      string
	Watchlists string
}{
	Animes:     "anime",
	Users:      "users",
	Watchlists: "watchlist",
}

var ColumnNames = struct {
	Animes     animeColumnNames
	Users      userColumnNames
	Watchlists watchlistColumnNames
}{
	Animes: animeColumnNames{
		ID:                "id",
		Romaji:            "romaji",
		English:           "english",
		Native:            "native",
		Format:            "format",
		Status:            "status",
		Description:       "description",
		StartYear:         "startYear",
		StartMonth:        "startMonth",
		StartDay:          "startDay",
		EndYear:           "endYear",
		EndMonth:          "endMonth",
		EndDay:            "endDay",
		Season:            "season",
		SeasonYear:        "seasonYear",
		Episodes:          "episodes",
		Duration:          "duration",
		CountryOfOrigin:   "countryOfOrigin",
		UpdatedAt:         "updatedAt",
		CoverImage:        "coverImage",
		AverageScore:      "averageScore",
		Popularity:        "popularity",
		AiringAt:          "AiringAt",
		NextAiringEpisode: "nextAiringEpisode",
	},
	Users: userColumnNames{
		UserID:       "user_id",
		Username:     "username",
		Passwordhash: "passwordhash",
	},
	Watchlists: watchlistColumnNames{
		ID:                "id",
		AnimeID:           "anime_id",
		UserID:            "user_id",
		Ratings:           "ratings",
		Status:            "status",
		AiringAt:          "airing_at",
		NextAiringEpisode: "next_airing_episode",
	},
}

var (
	SelectWhere = Where[*dialect.SelectQuery]()
	InsertWhere = Where[*dialect.InsertQuery]()
	UpdateWhere = Where[*dialect.UpdateQuery]()
	DeleteWhere = Where[*dialect.DeleteQuery]()
)

func Where[Q psql.Filterable]() struct {
	Animes     animeWhere[Q]
	Users      userWhere[Q]
	Watchlists watchlistWhere[Q]
} {
	return struct {
		Animes     animeWhere[Q]
		Users      userWhere[Q]
		Watchlists watchlistWhere[Q]
	}{
		Animes:     AnimeWhere[Q](),
		Users:      UserWhere[Q](),
		Watchlists: WatchlistWhere[Q](),
	}
}

var (
	SelectJoins = getJoins[*dialect.SelectQuery]
	UpdateJoins = getJoins[*dialect.UpdateQuery]
	DeleteJoins = getJoins[*dialect.DeleteQuery]
)

type joinSet[Q any] struct {
	InnerJoin Q
	LeftJoin  Q
	RightJoin Q
}

type joins[Q dialect.Joinable] struct {
	Animes     joinSet[animeRelationshipJoins[Q]]
	Users      joinSet[userRelationshipJoins[Q]]
	Watchlists joinSet[watchlistRelationshipJoins[Q]]
}

func getJoins[Q dialect.Joinable](ctx context.Context) joins[Q] {
	return joins[Q]{
		Animes:     animesJoin[Q](ctx),
		Users:      usersJoin[Q](ctx),
		Watchlists: watchlistsJoin[Q](ctx),
	}
}
